function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import PropTypes from 'prop-types';
import React, { Component } from 'react';
import { Modal } from 'antd';
import KeycodeInput from './keycode-input.js';

var KeycodeInputModal = function (_Component) {
  _inherits(KeycodeInputModal, _Component);

  function KeycodeInputModal() {
    _classCallCheck(this, KeycodeInputModal);

    return _possibleConstructorReturn(this, _Component.apply(this, arguments));
  }

  KeycodeInputModal.prototype.render = function render() {
    var _props = this.props,
        initialSeconds = _props.initialSeconds,
        codeLength = _props.codeLength,
        width = _props.width,
        visible = _props.visible,
        onlyNumber = _props.onlyNumber,
        onResend = _props.onResend,
        onComplete = _props.onComplete,
        onCancel = _props.onCancel,
        lang = _props.lang,
        style = _props.style,
        mobile = _props.mobile;

    return React.createElement(
      Modal,
      {
        maskClosable: false,
        style: style,
        footer: null,
        title: null,
        onCancel: onCancel,
        width: width,
        visible: visible },
      React.createElement(KeycodeInput, {
        initialSeconds: initialSeconds,
        codeLength: codeLength,
        onlyNumber: onlyNumber,
        onResend: onResend,
        onComplete: onComplete,
        visible: visible,
        lang: lang,
        mobile: mobile
      })
    );
  };

  return KeycodeInputModal;
}(Component);

KeycodeInputModal.propTypes = {
  initialSeconds: PropTypes.number,
  mobile: PropTypes.string,
  codeLength: PropTypes.number,
  style: PropTypes.object,
  width: PropTypes.number,
  visible: PropTypes.bool,
  onlyNumber: PropTypes.bool,
  onResend: PropTypes.func,
  onComplete: PropTypes.func,
  onCancel: PropTypes.func
};
KeycodeInputModal.defaultProps = {
  codeLength: 4,
  initialSeconds: 60,
  onlyNumber: true,
  lang: 'en',
  style: {},
  width: 330
};
export default KeycodeInputModal;