'use strict';

exports.__esModule = true;

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _antd = require('antd');

var _keycodeInput = require('./keycode-input.js');

var _keycodeInput2 = _interopRequireDefault(_keycodeInput);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var KeycodeInputModal = function (_Component) {
  _inherits(KeycodeInputModal, _Component);

  function KeycodeInputModal() {
    _classCallCheck(this, KeycodeInputModal);

    return _possibleConstructorReturn(this, _Component.apply(this, arguments));
  }

  KeycodeInputModal.prototype.render = function render() {
    var _props = this.props,
        initialSeconds = _props.initialSeconds,
        codeLength = _props.codeLength,
        width = _props.width,
        visible = _props.visible,
        onlyNumber = _props.onlyNumber,
        onResend = _props.onResend,
        onComplete = _props.onComplete,
        onCancel = _props.onCancel,
        lang = _props.lang,
        style = _props.style,
        mobile = _props.mobile;

    return _react2.default.createElement(
      _antd.Modal,
      {
        maskClosable: false,
        style: style,
        footer: null,
        title: null,
        onCancel: onCancel,
        width: width,
        visible: visible },
      _react2.default.createElement(_keycodeInput2.default, {
        initialSeconds: initialSeconds,
        codeLength: codeLength,
        onlyNumber: onlyNumber,
        onResend: onResend,
        onComplete: onComplete,
        visible: visible,
        lang: lang,
        mobile: mobile
      })
    );
  };

  return KeycodeInputModal;
}(_react.Component);

KeycodeInputModal.propTypes = {
  initialSeconds: _propTypes2.default.number,
  mobile: _propTypes2.default.string,
  codeLength: _propTypes2.default.number,
  style: _propTypes2.default.object,
  width: _propTypes2.default.number,
  visible: _propTypes2.default.bool,
  onlyNumber: _propTypes2.default.bool,
  onResend: _propTypes2.default.func,
  onComplete: _propTypes2.default.func,
  onCancel: _propTypes2.default.func
};
KeycodeInputModal.defaultProps = {
  codeLength: 4,
  initialSeconds: 60,
  onlyNumber: true,
  lang: 'en',
  style: {},
  width: 330
};
exports.default = KeycodeInputModal;